/*
 * GNUTrekCGIlib 0.2   --   http://www.trek.eu.org/trekcgi/?lib
 * Copyright (C) 1999,2000 Trek <trek@mediaservice.net> <trek00@freenet.hut.fi>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 * or see http://www.opensource.org/licenses/gpl-license.html
 */
#ifndef __TREKCGILIB_H__
#define __TREKCGILIB_H__

#define TREKCGILIBVERSION 000200

/* keyword max lenght */
#define KEYSIZE 32


/*
 * Read the query string (after the ? in the url)
 * querystr is the string from server and queryp an enviroment like
 *  array of variables
 * Return queryp address or NULL if it fault
 */
char **parsequery(char *querystr, char **queryp);

/*
 * Extract values from the enviroment
 * enviroment is composed: keyword=value\n
 */
int extract_env(char **env, char *keyword, char *value, int valuesize);

/*
 * Convert a value to readable contents from http specs
 * querystr is the string from server, outstr is a buffer of
 *  outsize bytes
 * Return the outstr lenght
 */
int convertstr(char *querystr, char *outstr, int outsize);

/*
 * Check if inputstr contains only allowed characters specified in chars
 * Return 0 if only allowed chars found or -1 for others
 */
int allowchars(char *inputstr, char *chars);


/*
 * Show the HTTP object from template with n values
 *  in the template the firsts declarations are associated
 *  in the same order with values
 */
int show_tmpl(char *template, char **values);

#endif /* __TREKCGILIB_H__ */
